#include <stdio.h> /* fgetc(3), fprintf(3), fputc(3), stderr, stdin, stdout,
                    * EOF */
#include <sysexits.h> /* EX_OK, EX_USAGE */
#include <unistd.h> /* getopt(3) */

/* untested */

int
usage(char *argv0) {
	(void)fprintf(stderr, "Usage: %s\n", argv0);
	return EX_USAGE;
}

int main(int argc, char *argv[]){
	int c;

	{
		int c;

		while ((c = getopt(argc, argv, "")) != -1) {
			switch (c) {
				default: return usage(argv[0]);
			}
		}
	}


#if 0
// Swapping algorithm:   For example, say c is 0b0101_0101 */
//                             /*                 <<< <<<< */
// c <<= 7;                    /* Now 0b010_1010_1000_0000 */
//                             /*              ^ >^        */
// c |= (c & (1 << 8)) >> 2;   /* Now 0b010_1010_1000_0000 */
//                             /*             ^> >>^       */
// c |= (c & (1 << 9)) >> 4;   /* Now 0b010_1010_1010_0000 */
//                             /*            ^>> >>>^      */
// c |= (c & (1 << 10)) >> 6;  /* Now 0b010_1010_1010_0000 */
//                             /*           ^>>> >>>> ^    */
// c |= (c & (1 << 11)) >> 8;  /* Now 0b010_1010_1010_1000 */
//                             /*         ^ >>>> >>>> >^   */
// c |= (c & (1 << 12)) >> 10; /* Now 0b010_1010_1010_1000 */
//                             /*        ^> >>>> >>>> >>^  */
// c |= (c & (1 << 13)) >> 12; /* Now 0b010_1010_1010_1010 */
//                             /*       ^>> >>>> >>>> >>>^ */
// c |= (c & (1 << 14)) >> 14; /* Now 0b010_1010_1010_1010 */
//                             /*   & 0b000_0000_1111_1111 */
// c &= 0xFF;                  /* Now          0b1010_1010 */
#endif

	{
		int c;
		int i;

		while ((c = fgetc(stdin)) != EOF) {
			for (c <<= 7, i = 8; i <= 14; ++i)
				{ c |= (c & (1 << i)) >> ((i - 7) * 2); }

			if (fputc(c, stdout) == EOF)
				{ perror(argv[0]); return EX_IOERR; }
		}
		if (ferror(stdin) != 0) { perror(argv[0]); return EX_IOERR; }
	}

	return EX_OK;
}
