/* 2025 DTB. Public domain. */

/* libkeyval is a key/value store library to be used for nonessential
 * applications due to lack of recoverability (errors fail assert(3)).
 * libkeyval deals with pointers and pointers only, and an effort has been made
 * to reflect the simplicity of the procedure in the code itself. */

/* keyval store */
#ifndef state_settings_size
#	define state_settings_size 100
#endif

struct State {
	size_t setting_last;
	struct Setting { char *key; char *val; } settings[state_settings_size];
};

void    cpy(char *key); /* Duplicate the setting key. */
void    del(char *key); /* Delete the first instance of key in settings. */
char *  get(char *key); /* Get the corresponding val to key in settings. */
int    getd(char *key); /* get() that returns a decimal number if key was a
                         * number, or 0. */
void keyval_init(void); /* Sanitize the settings store. */
size_t  idx(char *key); /* Returns the index of key if in settings, or
                         * state.setting_last. */
size_t ren(char *key, char *dst); /* Rename the first instance of key in
                                   * settings. */
size_t set(char *key, char *val); /* Set the first instance of key in
                                   * settings. */
