/* 2025 DTB. Public Domain. */
// #undef NDEBUG /* LOAD BEARING ASSERTS */
// #include <assert.h> /* assert(3) */
// #include <stdlib.h> /* setenv(3), unsetenv(3), NULL */
// #include <time.h> /* localtime(3), strftime(3), time(2), tzset(3), time_t,
//                    * struct tm */
// #include "io.h" /* out(3) */
// #include "keyval.h" /* get(3) */
#ifndef mod_time_bufsize
#	define mod_time_bufsize 100
#endif

void
set_timezone(char *zone) {
	if (zone == NULL) { assert(unsetenv("TZ") == 0); }
	else { assert(setenv("TZ", zone, 1) == 0); }
	tzset();
}

void
mod_time(char *fmt) {
	static char buf[mod_time_bufsize];
	struct tm *tm;
	static time_t t = 0;
	static tick_t last_tick = 0;

	if (ticker == 0) { t = time(NULL); }
	else if (ticker != last_tick) { t += slept; }
	last_tick = ticker;
	assert((tm = localtime(&t)) != NULL);
	assert(strftime(buf, sizeof(buf) / sizeof(*buf), fmt, tm) != 0);

	out(buf);
	out(get("separator"));
}
